<?php
function get_curr($keyt) {
    //     
    $list = array(
        '999' => 'UNI',
        '810' => 'RUR',
        '840' => 'USD',
        '978' => 'EUR',
        '980' => 'UAH'
    );

    return $list[substr($keyt, 5, 3)];
}

function hmac($key, $data) {
    //    HMAC
    $b = 64; // byte length for md5

    if ( strlen($key) > $b ) {
        $key = pack("H*",md5($key));
    }

    $key = str_pad($key, $b, chr(0x00));
    $k_ipad = $key ^ str_pad(null, $b, chr(0x36));
    $k_opad = $key ^ str_pad(null, $b, chr(0x5c));

    return md5($k_opad . pack("H*",md5($k_ipad . $data)));
}

function _GetExtTransact() {
    //     -   
    $tm = localtime(time(), 1);
    $r = rand(1111,9999);

    return sprintf(
        "%04d%02d%02d%02d%02d%02d%04d",
        $tm["tm_year"] + 1900,
        $tm["tm_mon"] + 1,
        $tm["tm_mday"],
        $tm["tm_hour"],
        $tm["tm_min"],
        $tm["tm_sec"], $r
    );
}

function alert($txt){
    return '<table align="center" border="0">
        <tr>
            <td colspan="2" align="center">
                <font face="arial"><b><h2>' . $txt . '</h2></b></font>
            </td>
        </tr>
    </table>';
}


class XML {
    var $Reader;
    var $Result;

    function XML($Data) {
        $this->Reader = new XMLReader();
        $this->Reader->XML($Data);
    }

    function Parse() {
        $Result = $this->GetArray($this->Reader);
        $Result = $Result['response'];

        return array(True, $Result);
    }


    function GetArray($XML) {
        $tree = null;

        while ( $XML->read() ) {
            switch ( $XML->nodeType ) {
                case XMLReader::END_ELEMENT:
                    return $tree;
                case XMLReader::ELEMENT:
                    $node = $XML->isEmptyElement ? null : $this->GetArray($XML);

                    if ( $XML->name == "colvalues" ) {
                        if ( $node != '' ) {
                            $tree[$XML->name][] = $node;
                        }
                    } else if ( $this->Found($tree, $XML->name) ) {
                        if ( !is_array($tree[$XML->name][0]) ) {
                            $TempTree = $tree[$XML->name];
                            $tree[$XML->name] = array();
                            $tree[$XML->name][0] = $TempTree;
                        }

                        $tree[$XML->name][] = $node;
                    } else {
                        $tree[$XML->name] = $node;

                        if ( $XML->name == "table" ) {
                            $ColCount = $XML->getAttribute("col");
                            $RowCount = $XML->getAttribute("row");
                            $tree[$XML->name]['colcount'] = $ColCount;
                            $tree[$XML->name]['rowcount'] = $RowCount;
                        }
                    }

                    break;
                case XMLReader::TEXT:
                case XMLReader::CDATA:
                    $tree .= mb_convert_encoding($XML->value, 'Windows-1251', 'UTF-8');

                    break;
            }
        }

        return $tree;
    }

    function Found($Arr, $Key) {
        if ( gettype($Arr) == 'array' ) {
            return in_array($Key,  array_keys($Arr));
        } else {
            return False;
        }
    }
}

$list = array(
    'ext_transact' => '  ',
    'keyt_shop' => ' ',
    'num_shop' => ' ',
    'identified' => '  ',
    'sum' => '',
    'comment' => '  ',
    'date' => '  ',
    'transact' => '   ',
    'status' => '  ',
    'status_text' => '  ',
    'result' => ' ',
    'result_text' => '  ',
    'sign' => ' ',
    'id_pay' => 'ID ',
    'keyt_pay' => ' ',
    'variant' => '  ',
    'user_name' => ' ,  ',
    'curr_shop' => ' ',
    'curr_pay' => ' ',
    'sys_comiss' => ' ',
    'dealer_persent' => '   ',
    'itogo' => ' ',
    'sys_persent' => '   ',
    'summ_pay' => ' ',
    'summ_shop' => ' ',
    'dealer_comiss' => ' ',
    'country_name' => '',
    'country' => ' ',
    'region' => ' ',
    'region_name' => ''
);

function get_command_info($array){
    global $list;

    $row_list = array();

    foreach ( $array as $key => $value ) {
        if ( !is_array($value) && strlen($value) > 0 ) {
            $row_list[] = array($key, $list[$key], $value);
        }
    }

    if ( isset($array['advanced']) ) {
        $advanced = $array['advanced'];

        foreach ( $advanced as $key => $value ) {
            $row_list[] = array($key, $list[$key], $value);
        }
    }

    $tr = null;

    foreach ( $row_list as $value ) {
        $tr .= '<tr>
            <td>
                <font face="arial" size="2"><b>' . $value[1] . '</b> <i>[' . $value[0] . ']</i>:&nbsp;&nbsp;</font>
            </td>
            <td>
                <font face="arial" size="2">' . $value[2] . '</font>
            </td>
        </tr>';
    }

    return '<table class="table_info"><td colspan="2" align="center"><b>  <br><br></b></td></tr>' . $tr . '</table>';
}

function createTables($tables){
    $res = null;

    if ( !isset($tables['colnames']) ) {
        foreach ( $tables as $table ) {
            $res .= createTables($table);
        }
    }

    $td = array();
    $rows = null;
    $row = null;
    $col_count = 0;

    foreach ( $tables['colnames'] as $td ) {
        ++$col_count;

        $row .= '<th>' . $td . '</th>';
    }

    $rows .= '<tr>' . $row . '</tr>';

    foreach ( $tables['colvalues'] as $td_list ) {
        $row = array();

        foreach ( $td_list as $td ) {
            $row[] = '<td>' . $td . '</td>';
        }

        while ( count($row) < $col_count ) {
            $row[] = '<td></td>';
        }

        $rows .= '<tr>' . implode($row) . '</tr>';
    }

    return $res . '<table style="margin:20px auto" cellpadding="5" cellspacing="0" border="1" bordercolor="gray" align="center">' . $rows . '</table>';
}

function get_header($title = null, $href = null){
    $html = <<<HTML

<!DOCTYPE html>
<html>
    <head>
        <title>{$title}</title>
        <meta http-equiv="Content-Type" content="text/html; windows-1251">
        <meta http-equiv="Content-Language" content="ru">
        <style>
            html, body {
                font-size:100%;
                margin:0;
                padding:0;
            }

            img {
                border:0;
            }

            .body {
                width:90%;
                margin:0 auto;
            }

            .header {
                text-align:center;
                padding:20px 0;
                border-bottom:4px solid #a0d7ed;
            }

            .desc {
                text-align:center;
                padding:10px 0 10px 0;
                font-size:110%;
            }

            input[type="text"] {
                padding:1px;
            }

            input[type="submit"] {
                padding:2px 5px;
            }

            .form {
                padding:10px 0 0 0;
                display:table;
                margin:0 auto;
            }

            .table_info {
                margin:20px auto 0;
            }
        </style>
    </head>
    <body>
        <div class="body">
            <div class="header">
                <a href="{$href}">
                    <img src='/img/top.gif'>
                </a>
            </div>
HTML;

    return $html;
}

function get_footer(){
    return <<<HTML
        </div>
    </body>
</html>
HTML;
}

function get_merchant_info(){
    return <<<HTML
<TABLE style="margin:20px auto;">
<TR>
    <td align=center><FONT face=arial size=2>
                Delta Key.<br>
          ,     " " ( ),      "".<br>
                 . <br>
                  .
    </td>
    </TR>
</TABLE>
HTML;
}?>